hdu1394--Minimum Inversion Number(线段树求逆序数,纯为练习)

Minimum Inversion Number

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 10326 Accepted Submission(s): 6359

Problem Description

The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.

For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:

a1, a2, ..., an-1, an (where m = 0 - the initial seqence)

a2, a3, ..., an, a1 (where m = 1)

a3, a4, ..., an, a1, a2 (where m = 2)

...

an, a1, a2, ..., an-1 (where m = n-1)

You are asked to write a program to find the minimum inversion number out of the above sequences.

Input

The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.

Output

For each case, output the minimum inversion number on a single line.

Sample Input

10
1 3 6 9 0 8 5 7 4 2

Sample Output

16

题目大意,从初始的数组开始,每次把第一个加到最后一个,求逆序数,共求出n个逆序数,找出最小值

对每种情况都求逆序数,可以每次都归并排序,或树状数组,或线段树,也可以由上一个的逆序数推出;

a[1] , a[2] , a[3] 。。。a[n],将a[1]放到最后,然后将a[2]放到最后,可以找到规律,将首个a[i]放到最后时,逆序数增加了 a[i]之前比a[i]大的,增加a[i]之后比a[i]大的,减小了a[i]之前比a[i]小的,减小了a[i]之后比a[i]小的,又因为每次给出的数n个数在0到n,且都不同,最后得出 逆序数会增加 n-a[i]个,减少a[i]-1个
#include <cstdio>
#include <cstring>
#define INF 0x3f3f3f3f
#include <algorithm>
using namespace std;
int tree[100000] , p[6000] , q[6000];
void update(int o,int x,int y,int u)
{
    if( x == y && x == u )
        tree[o]++ ;
    else
    {
        int mid = (x + y)/ 2;
        if( u <= mid )
            update(o*2,x,mid,u);
        else
            update(o*2+1,mid+1,y,u);
        tree[o] = tree[o*2] + tree[o*2+1];
    }
}
int sum(int o,int x,int y,int i,int j)
{
    int ans = 0 ;
    if( i <= x && y <= j )
        return tree[o] ;
    else
    {
        int mid = (x + y) /2 ;
        if( i <= mid )
            ans += sum(o*2,x,mid,i,j);
        if( mid+1 <= j )
            ans += sum(o*2+1,mid+1,y,i,j);
    }
    return ans ;
}
int main()
{
    int i , j , n , min1 , num ;
    while(scanf("%d", &n)!=EOF)
    {
        min1 = 0 ;
        memset(q,0,sizeof(q));
        for(i = 1 ; i <= n ; i++)
        {
            scanf("%d", &p[i]);
            p[i]++ ;
        }
        memset(tree,0,sizeof(tree));
        for(i = 1 ; i <= n ; i++)
        {
            min1 += sum(1,1,n,p[i],n);
            update(1,1,n,p[i]);
        }
        num = min1 ;
        for(i = 1 ; i < n ; i++)
        {
            num = num + ( n - p[i] ) - (p[i] - 1) ;
            if( num < min1 )
                min1 = num ;
        }
        printf("%d\n", min1);
    }
    return 0;
}

hdu1394--Minimum Inversion Number(线段树求逆序数,纯为练习),布布扣,bubuko.com

时间: 2024-10-14 14:43:53

hdu1394--Minimum Inversion Number(线段树求逆序数,纯为练习)的相关文章

HDU 1394- Minimum Inversion Number(线段树求逆序数)

Minimum Inversion Number Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 1394 Appoint description:  System Crawler  (2015-04-13) Description The inversion number of a given number sequence a1, a

hdu1394 Minimum Inversion Number(线段树单点更新||暴力)

题目链接: huangjing 这个题目暴力和线段树都可以过,但是都需要掌握一个规律.. 当队首元素移到队尾后,可定会减少a[i]个逆序对,然后增加n-1-a[i]个逆序对. 你看比如1移到队尾,那么1>0这个逆序对就会减少,2>1,3>1,4>1这些逆序对就会增加.. 所以发现这个规律就好做了.. 暴力做法就是直接那样模拟.. 线段树做法是首先建立一颗空树,然后插入之前询问这颗树中在[插入元素,n]之间的树,求出来的就是逆序对的个数.然后将其更新进去即可.. 题目: 寻人启事:2

HDU1394 Minimum Inversion Number 线段树+数学

Problem Description The inversion number of a given number sequence a1, a2, -, an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, -, an, if we move the first m >= 0 numbers to the end of the

hdu1394 Minimum Inversion Number 线段树和树状数组

题意: 输入一个长度 n 第二行给出长度为n的数组,数组的值刚好为0到n-1这n个数. 然后每次把数组的第一个数放到最后一个,放n-1次,共有n个排列,这n个排列就有n个逆序数,输出这n个逆序数的最小值. 我的做法: 1.每次输入a[i]后,都把a[i] ++; 2.求出第一个排列的逆序数 3.递推求出所有的逆序数 那怎么求1呢? 对于每一个a[i],求出1到i-1 中比它大的个数,然后相加,即可得.若用朴素的查找,肯定会超时的,所以这里就利用线段树或者树状数组来快速查找. 线段树版本: 1 #

HDU 1394 Minimum Inversion Number(线段树求逆序数)

题目地址:HDU 1394 这题可以用线段树来求逆序数. 这题的维护信息为每个数是否已经出现.每次输入后,都从该点的值到n-1进行查询,每次发现出现了一个数,由于是从该数的后面开始找的,这个数肯定是比该数大的.那就是一对逆序数,然后逆序数+1.最后求完所有的逆序数之后,剩下的就可以递推出来了.因为假如目前的第一个数是x,那当把他放到最后面的时候,少的逆序数是本来后面比他小的数的个数.多的逆序数就是放到后面后前面比他大的数的个数.因为所有数都是从0到n-1.所以比他小的数就是x,比他大的数就是n-

HDU - 1394 Minimum Inversion Number (线段树求逆序数)

Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seq

Minimum Inversion Number(线段树单点更新+逆序数)

Minimum Inversion Number(线段树单点更新+逆序数) Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy

hdu 1394 Minimum Inversion Number 线段树 点更新

// hdu 1394 Minimum Inversion Number 线段树 点更新 // // 典型线段树的单点更新 // // 对于求逆序数,刚开始还真的是很年轻啊,裸的按照冒泡排序 // 求出最初始的逆序数,然后按照公式递推,结果就呵呵了 // // 发现大牛都是用线段树和树状数组之类的做的,而自己又在学 // 线段树,所以就敲了线段树. // // 线段树的节点保存一段区间( L,R )内0,1...n一共出现了多少个. // 因为每个数是0,1,2...n-1且没有重复的数字. /

HDU 1394 Minimum Inversion Number.(线段树)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1394 ~~~~ 早起一发线段树,开心又快乐.这题暴力也能水过,同时线段树的效率也就体现的尤为明显了,看了大牛的博客,说是还可以用树状数组,点树和合并序列写,现在还不懂,留着以后在写吧. ~~~~ 大致题意:给定一个数字序列,同时由此可以得到n个序列, 要求从n个序列中找到逆序数最小的序列,输出最小逆序数. 首先介绍下逆序数的概念: 在一个排列中,如果一对数的前后位置与大小顺序相反,即前面的数大于后面